 
c Copyright (c) 1990 by James A. D. Connolly, Institute for Mineralogy and
c Petrography, Swiss Federal Insitute of Technology, CH-8092 Zurich,
c SWITZERLAND. All rights reserved.
 
c PSVDRAW - a program to generate postscript code for x-y plots and chemographic
c phase diagrams.  The input data format is consistent with the files generated
c by the programs VERTEX and FRENDLY.
 
c Please do not distribute any part of this source.
 
 
      PROGRAM PVDRAW
 
      integer h9
 
      parameter (k1=1000,h9=18)
 
      character*80 fname, yes*1, names*8, sname*10
 
      common / cst8 /names(k1)/ csta7 /sname(h9)
      common / xyrat /xfac
 
      n4 = 24
 
      write (*,1020) 
      read (*,1000) fname
 
      open (n4,err=90,file=fname,status='old')
      icopt = 1
 
      call psopen (fname,ier)
      goto (999), ier
  
      write (*,1030) 
      read (*,1010) yes
      iop0 = 0
      if (yes.eq.'y'.or.yes.eq.'Y') iop0 = 1

      xfac = 1.0
      call psxypl (n4,iop0,icopt)
  
      goto 99
90    write (*,1040) fname
      goto 999
 
99    call psclos
 
      close (99)
 
1000  format (a80)
1010  format (a1)
1020  format (/,' Enter plot file name: ',/)
1030  format (/,' Modify the default plot (y/n)? ',/)
1040  format (/,' no such file as: ',a14,/)
1050  format (/,a14,' is not formatted correctly.',/)
 
999   end
c---------------------------------------------------------------------
      subroutine psxypl (n4,iop0,icopt)
 
c psxypl - subroutine to output x-y plot.
 
      character*72 fname(4),vname*30, names*8, sname*10
 
      integer h9, k1
 
      parameter (k1=1000,h9=18,k9=2000)
 
      common / cst8 /names(k1)/ csta7 /sname(h9)/ phase /ikp(k1)
      common/ vs    /vmin(5),vmax(5),iv/ vsa /vname(5)
      common/ excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
      common / xypts /xpt(k9),ypt(k9),isym(k9),ipts
 
      iv = 2
      ipts = 1
      vmin(1) = 1.d99
      vmax(1) = -1.d99
      vmin(2) = 1.d99
      vmax(2) = -1.d99
      vname(1) = 'x axis'
      vname(2) = 'y axis'
      fname(1) = 'title'

10    read (n4,*,end=30) isym(ipts),xpt(ipts),ypt(ipts)
      if (xpt(ipts).lt.vmin(1)) vmin(1) = xpt(ipts)
      if (xpt(ipts).gt.vmax(1)) vmax(1) = xpt(ipts)
      if (ypt(ipts).gt.vmax(2)) vmax(2) = ypt(ipts)
      if (ypt(ipts).lt.vmin(2)) vmin(2) = ypt(ipts)
      ipts = ipts + 1
      goto 10
c                                 get some options and
c                                 set up transformations
30    call psaxop (iop0,iop1,jop0,jwidth,icopt)

      ipts = ipts - 1

      call psvdrw (n4,fname,iop0,iop1,jwidth,jop0)
 
      call psaxes (jwidth,jop0)
 
1000  format (a72)
1010  format (10a8)
1020  format (2x,a30)
1030  format (8a10)

      end
c----------------------------------------------------------------------
      subroutine psaxop (iop0,iop1,jop0,jwidth,icopt)

c psaxop - subroutine to make graphics transformation and get some options

      character yes*1, vname*30

      common / wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
      common/ vs    /vmin(5),vmax(5),iv/ vsa /vname(5)
      common / xyrat /xfac


      dsx = 0.18
      dsy = 0.18
      dtx = 160.
      dty = 220.
      drot = 0.
      jop0 = 0
      jwidth = 1 

      if (icopt.ne.3.and.iop0.eq.1) then
c                                     modify default drafting
c                                     options?          
         write (*,1090) 
         read (*,1030) yes
         if (yes.eq.'y'.or.yes.eq.'Y') jop0 = 1

       else if (icopt.eq.3) then

          jop0 = iop0

       end if 

       if (jop0.eq.1) then
 
         if (icopt.eq.3) goto 10 

         write (*,1070) 
         read (*,1030) yes
         iop1 = 0
 
         if (yes.eq.'y'.or.yes.eq.'Y') then
            write (*,1040) vname(1),vmin(1),vmax(1)
            read (*,*) vmin(1),vmax(1)
            write (*,1040) vname(2),vmin(2),vmax(2)
            read (*,*) vmin(2),vmax(2)
            iop1 = 1
            write (*,1080) 
         end if

10       write (*,1100)
         read (*,1030) yes

         if (yes.eq.'y'.or.yes.eq.'Y') then

            write (*,1110) dsx,dsy,dtx,dty,drot
            read (*,*) dsx,dsy,dtx,dty,drot

         end if 

         write (*,1130)
         read (*,1030) yes

         if (yes.eq.'y'.or.yes.eq.'Y') then

            write (*,1140) 
            read (*,*) xfac

         end if 

         if (icopt.eq.3) goto 20 

         write (*,1120) 
         read (*,1030) yes
         if (yes.eq.'y'.or.yes.eq.'Y') jwidth = 0
 
      end if

20    xmax = vmax(1)
      xmin = vmin(1)
      ymax = vmax(2)
      ymin = vmin(2)
      xlen = xmax - xmin
      ylen = ymax - ymin
c                                     set default char size, based
c                                     on font 7 (helv 14) the axes
c                                     length is about 85 characters
      dcx = xlen / 85.
      dcy = ylen / 85.
 
      call psssc2 (xmin,xmax,ymin,ymax)

c      call pssscm (xfac, 1.0)

      dsx = dsx * xfac
 
      call psstrn (dsx,dsy,dtx,dty,drot)

1030  format (a1)
1040  format (/,' Enter new min and max for ',a8,' old values ',
     *        ' were: ',2(g11.5,1x),/)
1070  format (/,' Modify x-y limits (y/n)? ',/)
1080  format (/,' OK, but this may look sloppy. ',/)
1090  format (/,' Modify default drafting options (y/n)?',/)
1100  format (/,' Modify default picture transformation (y/n)?',/)
1110  format (/,' The default values for x-y scaling, x-y',
     *          ' translation, and rotation',/,' are, respectively:',
     *        /,(5(4x,g8.3)),/,' Enter the new values:',/)
1120  format (/,' Use minimum width lines (y/n)?',/)
1130  format (/,' Modify ratio of x to y axis length (y/n)',/)
1140  format (/,' Enter fractional length of x axis relative',
     *          ' to the y axis:',/)

      end 
c----------------------------------------------------------------------
      subroutine pschem (n4)
 
c pschem - subroutine to output ternary chemographies.
  
      parameter (k1=1000,k2=2000)
 
      character*8 names, vname*30, title*72, record*72
 
      common / cst8 /names(k1)
 
      real x(3,k1), x3(3), y3(3), xx(3), yy(3)
 
      integer idf(4,k2), iasmbl(k2), idss(10), ivchk(k1)
 
      common/ vs    /vmin(5),vmax(5),iv/ vsa /vname(5)
 
      save x3,y3,dxt,dyt,yt,xt
 
      data x3,y3,dxt,dyt,yt,xt/0.0,0.5,1.0,0.0,0.866025,0.0,
     *                         250.,300.,980.,100./
      
      iflag = 0
c                                  read simple variables
10    read (n4,*) icp,istct,iphct,ipoint,ib,ifyn,isyn,ipot

      if (icp.ne.3) then 
         write (*,*) ' Sorry, PSVDRAW only works',
     *               ' for ternary composition diagrams.'
         stop
      end if 
 
      if (iphct.gt.k1.or.iv.gt.5
     *                 .or.ib.gt.k2.or.ipot.gt.5) then
         write (*,*) ' dimensioning error in pschem'
         goto 99
      end if

      do 11 i = 1, iphct
11       ivchk(i) = 0 
 
      read (n4,1000) (vname(i),i=1,ipot)
      read (n4,*) (vmin(i),i=1,ipot)
      read (n4,1010) title
 
      icp1 = icp - 1
c                                  names
      read (n4,1020) (names(i), i = 1, iphct)
c                                  phase coordinates
      read (n4,*) ((x(j,i),j=1,icp1),i=istct,iphct)
c                                  read phase configurations
      read (n4,*) ((idf(j,i),j=1,icp),i=1,ib)
c                                  read assemblage flags
      read (n4,*) (iasmbl(i), i = 1, ib)
c                                  read saturated phase id's
      goto (20),isyn
 
      read (n4,*) isat
      read (n4,*) (idss(i), i = 1, isat)
 
20    iflag = (iflag-1)**2
 
      if (iflag.eq.0) then
         xt = 375.
      else
         yt = yt - dyt
         xt = 75.
      end if
 
      call psssc2 (0.,1.,0.,1.)
 
      call psstrn (0.08,0.08,xt,yt,0.)
 
      call pspygn  (x3,y3,3,1.,2,0)
 
      do 1 i = 1, ib
 
         ias = iasmbl(i)
 
         do 2 j = 1, 3
            id = idf(j,i)
            if (ivchk(id).eq.2) goto 15
            ivchk(id) = 2
            goto (15), ias
            ivchk(id) = 1
15          xx(j) = x(1,id) + 0.5 * x(2,id)
            yy(j) = x(2,id) * 0.866025
2        continue
 
         rias = ias
 
         if (ias.eq.1) then
            call pspygn  (xx,yy,3,rias,2,0)
         else if (ias.eq.2) then
            call pspygn  (xx,yy,3,rias,0,0)
         else if (ias.eq.3) then
            call pspygn  (xx,yy,3,rias,0,4)
         else if (ias.eq.4) then
            call pspygn  (xx,yy,3,rias,0,0)
         end if
1     continue
 
      do 3 i = istct, iphct
         if (ivchk(i).ne.0) then
            if (i.le.ipoint) then
               call pssctr (7,1.2,1.2,0.)
               x1 = x(1,i) + 0.5 * x(2,i) + 0.02
               y1 = x(2,i) * 0.866025
               call pstext (x1,y1,names(i),8)
               call pselip (x1-0.02,y1,0.015,0.015,0.,0,7)
            else
               if (ivchk(i).eq.2) then
                  call pssctr (8,1.2,1.2,0.)
                  x1 = x(1,i) + 0.5 * x(2,i) + 0.015
                  y1 = x(2,i) * 0.866025
                  call pstext (x1,y1,names(i),8)
                  call pselip (x1-0.015,y1,0.01,0.01,0.,0,7)
               end if
            end if
         end if
         ivchk(i) = 0
3     continue
c                                       sectioning constraints
         call pssctr (8,1.2,1.2,0.)
         y = 1.
         do  4 i = 1, ipot
            write (record,1040) vname(i),vmin(i)
            nchar = 0 
            call psublk (record,nchar)
            call pstext (0.75,y,record,nchar)
4           y = y - 0.06
 
         if (ifyn.eq.0) then 
            call pstext (0.75,y,'(fluid saturated)',17)
            y = y - 0.06
         end if 
         if (isyn.eq.0) then
            write (record,1050) (names(idss(i)),i=1,isat)
            nchar = 72 
            call psublk (record,nchar)
            call pstext (0.75,y,record,nchar)
         end if 
 
      read (n4,1030,end=99) icopt
 
      goto 10
 
1000  format (2x,a30)
1010  format (a72)
1020  format (10(a8))
1030  format (bn,i80)
1040  format (a8,'=',g9.3)
1050  format ('+ ',6(a8,' '))
 
99    end
c----------------------------------------------------------------------
      subroutine psaxes (iwidth,jop0)
 
c psaxes - subroutine to output (sloppy) axes.
 
      character*30 vname, record, yes*1
 
      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
      common/ vs    /vmin(5),vmax(5),iv/ vsa /vname(5)
      common / xyrat /xfac
 
      ihalf = 1
      itenf = 0
      igrid = 0
      rline = 1.

      csn = 1.
      csa = 1.

      x0 = xmin
      y0 = ymin
      dx = xlen / 5.
      dy = ylen / 5.

      xtic  = xlen/45.
      xtic1 = xtic*.67
      xtic2 = xtic1*.67
 
      ytic  = ylen/45.
      ytic1 = ytic*.67
      ytic2 = ytic1*.67 

      if (jop0.eq.1) then
         write (*,1010) 
         read (*,1020) yes
         if (yes.ne.'y'.and.yes.ne.'Y') goto 10

         write (*,1030) 'X', x0, dx
         read (*,*) x0, dx
         write (*,1030) 'Y', y0, dy
         read (*,*) y0, dy

         write (*,1040)
         read (*,1020) yes
         if (yes.eq.'y'.or.yes.eq.'Y') ihalf = 0

         write (*,1050) 
         read (*,1020) yes
         if (yes.eq.'y'.or.yes.eq.'Y') itenf = 1

         write (*,1070) 
         read (*,1020) yes
         if (yes.eq.'y'.or.yes.eq.'Y') then 
            write (*,1060) 
            read (*,*) csn, csa
         end if

         write (*,1080) 
         read (*,1020) yes 
         if (yes.eq.'y'.or.yes.eq.'Y') igrid = 1
     
      end if 
c                                       draw axes box
10    call psrect (xmin,xmax,ymin,ymax,1.,iwidth,0)
c                                       draw left vertical axis tics
      call psytic (xmin, y0, dy, xtic, xtic1, xtic2, rline, 
     *             ihalf, itenf, iwidth)
c                                       draw right vertical axis
      call psytic (xmax, y0, dy, -xtic, -xtic1, -xtic2, rline, 
     *             ihalf, itenf, iwidth)
c                                       draw bottom horizontal axis
      call psxtic (ymin, x0, dx, ytic, ytic1, ytic2, rline,
     *             ihalf, itenf, iwidth)
c                                       draw top horizontal axis
      call psxtic (ymax, x0, dx, -ytic, -ytic1, -ytic2, rline, 
     *             ihalf, itenf, iwidth)
 
      call pssctr (7,csn*1.2,csn*1.2,0.)

      cx = dcx * csn
      cy = dcy * csn 
c                                       numeric axis labels:
      call psylbl (xmin, xmax, y0, ymax, dy, cx, cy, tmin, igrid) 
 
      call psxlbl (x0, dx, cx, 2.3*cy, igrid)

      cx = dcx * csa
      cy = dcy * csa
c                                       x-axis name
      call pssctr (7,csa*2.,csa*2.,0.0)
      t = xmin + 0.5 * xlen - (7. * cx) / xfac
      call pstext (t, ymin - 0.07 * ylen, vname(1),0)
c                                       y-axis name
      call pssctr (7,csa*2.,csa*2., 90.)
      t = tmin - 5. * cx / xfac 
      call pstext (t, ymin + 0.43 * ylen,vname(2),0)
c                                       sectioning constraints
      if (iv.gt.2) then
 
         call pssctr (8,csa*1.2,csa*1.2,0.)
         y = ymax + 0.12 * ylen
         do 1 i = 3, iv
            write (record,1000) vname(i),vmin(i)
            call pstext (xmin,y,record,0)
1           y = y - 0.037 * ylen
 
      end if
 
1000  format (a8,'=',g9.3)
1010  format (/,' Modify default axes (y/n)?',/)
1020  format (a1)
1030  format (/,' Enter the starting value and interval for',
     *          ' major tick marks on',/,' the ',a1,'-axis (the'
     *          ' current values are:',2(1x,g9.3),')',/, 
     *          ' Enter the new values:',/)
1040  format (/,' Cancel half interval tick marks (y/n)?',/)
1050  format (/,' Draw tenth interval tick marks (y/n)?',/)
1060  format (/,' Enter scale factors for numeric and text',
     *          ' axes labels:') 
1070  format (/,' Rescale axes text (y/n)?',/)
1080  format (/,' Turn gridding on (y/n)?',/)
      end
c------------------------------------------------------------------
      subroutine psytic (x0, y0, dy, tic, tic1, tic2, rline, ihalf,
     *                   itenf, iwidth)

      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen

c psytic - subroutine to draw y-axis ticks.

      y = y0 
      call psmove (x0,y0)

      if (ihalf.eq.0.and.itenf.eq.0) then 

10       if (y.ge.ymax) goto 99
         call psrlin (tic,0.,rline,iwidth)
         call psrmov (-tic,dy)
         y = y + dy 
         goto 10

      else if (itenf.eq.0) then

         dy2 = dy / 2.

20       if (y.ge.ymax) goto 30
         call psrlin (tic,0.,rline,iwidth)
         call psrmov (-tic,dy2)
         y = y + dy2
         if (y.ge.ymax) goto 30
         call psrlin (tic1, 0., rline, iwidth)
         call psrmov (-tic1,dy2)
         y = y + dy2
         goto 20

30       if (y0-dy2.gt.ymin)
     *      call psline (x0,y0-dy2,x0+tic1,y0-dy2,rline,iwidth)
         goto 99

      else

         dy2 = dy / 10.

40       if (y.ge.ymax) goto 50
         call psrlin (tic, 0., rline, iwidth)
         call psrmov (-tic, dy2)
         y = y + dy2

         do 60 i = 1, 4
            if (y.ge.ymax) goto 50
            call psrlin (tic2, 0., rline, iwidth)
            call psrmov (-tic2, dy2)
60          y = y + dy2

         if (y.ge.ymax) goto 50
         call psrlin (tic1, 0., rline, iwidth)
         call psrmov (-tic1, dy2)
         y = y + dy2

         do 70 i = 1, 4
            if (y.ge.ymax) goto 50
            call psrlin (tic2, 0., rline, iwidth)
            call psrmov (-tic2, dy2)
70          y = y + dy2

         goto 40

50       if (y0-dy2.lt.ymin) goto 99

         y = y0 - dy2
         call psmove (x0,y)

         do 80 i = 1, 4
            if (y.le.ymin) goto 99
            call psrlin (tic2, 0., rline, iwidth)
            call psrmov (-tic2, -dy2)
80          y = y - dy2

         if (y.le.ymin) goto 99
         call psrlin (tic1, 0., rline, iwidth)
         call psrmov (-tic1, -dy2)
         y = y - dy2 

         do 90 i = 1, 4
            if (y.le.ymin) goto 99
            call psrlin (tic2, 0., rline, iwidth)
            call psrmov (-tic2, -dy2)
90          y = y - dy2

      end if 

99    end

c------------------------------------------------------------------
      subroutine psxtic (y0, x0, dx, tic, tic1, tic2, rline, ihalf,
     *                   itenf, iwidth)

      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen

c psxtic - subroutine to draw x-axis ticks.

      x = x0 
      call psmove (x0,y0)

      if (ihalf.eq.0.and.itenf.eq.0) then 

10       if (x.ge.xmax) goto 99
         call psrlin (0., tic, rline, iwidth)
         call psrmov (dx, -tic)
         x = x + dx 
         goto 10

      else if (itenf.eq.0) then

         dx2 = dx / 2.

20       if (x.ge.xmax) goto 30
         call psrlin (0., tic, rline, iwidth)
         call psrmov (dx2, -tic)
         x = x + dx2
         if (x.ge.xmax) goto 30
         call psrlin (0., tic1, rline, iwidth)
         call psrmov (dx2, -tic1)
         x = x + dx2
         goto 20

30       if (x0-dx2.gt.xmin)
     *      call psline (x0-dx2, y0, x0+tic1, y0, rline, iwidth)
         goto 99

      else

         dx2 = dx / 10.

40       if (x.ge.xmax) goto 50
         call psrlin (0., tic, rline, iwidth)
         call psrmov (dx2, -tic)
         x = x + dx2

         do 60 i = 1, 4
            if (x.ge.xmax) goto 50
            call psrlin (0., tic2, rline, iwidth)
            call psrmov (dx2, -tic2)
60          x = x + dx2

         if (x.ge.xmax) goto 50
         call psrlin (0., tic1, rline, iwidth)
         call psrmov (dx2, -tic1)
         x = x + dx2

         do 70 i = 1, 4
            if (x.ge.xmax) goto 50
            call psrlin (0., tic2, rline, iwidth)
            call psrmov (dx2, -tic2)
70          x = x + dx2

         goto 40

50       if (x0-dx2.lt.xmin) goto 99

         x = x0 - dx2

         call psmove (x, y0)

         do 80 i = 1, 4
            if (x.le.xmin) goto 99
            call psrlin (0., tic2, rline, iwidth)
            call psrmov (-dx2, -tic2)
80          x = x - dx2

         if (x.le.xmin) goto 99
         call psrlin (0., tic1, rline, iwidth)
         call psrmov (dx2, -tic1) 
         x = x - dx2 

         do 90 i = 1, 4
            if (x.le.xmin) goto 99
            call psrlin (0., tic2, rline, iwidth)
            call psrmov (-dx2, -tic2)
90          x = x - dx2

      end if 

99    end
 
      subroutine psylbl (xmin, xmax, y0, ymax, dy, 
     *                   dcx, dcy, tmin, igrid)
 
c psylbl - subroutine to put on y-axis labels.
 
      character*12 numbs(40)
 
      integer ic(40)

      common / xyrat /xfac

      xdc = 1.4 * dcx
      ydc = .8 * dcy
      tmin = 1.d30
 
      call psnum (y0,ymax,dy,ic,iy1,numbs)
 
      y = y0
 
      do 10 i = 1, iy1
 
         t = xmin - (float(ic(i)+1) * xdc) / xfac
         if (t.lt.tmin) tmin = t
         call pstext (t, y + ydc, numbs(i), ic(i))
         if (igrid.eq.1) call psline (xmin, y, xmax, y, 10., 0)
 
10    y = y + dy
 
      end
 
      subroutine psnum (rmin,rmax,dr,ic,i1,numbs)
 
      character*1 text(12), numbs(40)*12, next(12)
 
      integer ic(40), k

      i1 = 1 + ifix ((rmax - rmin) / dr)
 
      if (rmax.gt. 9999.9 .and.rmax.lt. 99999.9 .and.rmin.gt.-rmax) then
         icase = 1
      else if (rmax.gt. 999.9 .and.rmax.le. 9999.9
     *                        .and.rmin.gt.-rmax) then
         icase = 2
      else if (rmax.gt. 99.9 .and.rmax.le. 999.9
     *                       .and.rmin.gt.-rmax) then
         icase = 3
      else
         icase = 4
      end if
 
      r = rmin
 
      do 10 i = 1, i1
         goto (1,2,3,4) icase
1        write (numbs(i),1001) ifix(r)
         goto 20
2        write (numbs(i),1002) ifix(r)
         goto 20
3        write (numbs(i),1003) ifix(r)
         goto 20
4        write (numbs(i),1004) r
20       read (numbs(i),1010) text
         k = 0
         do 30 j = 1, 12
            if (text(j).eq.' ') goto 30
            k = k + 1
            next(k) = text(j)
30       continue
         ic(i) = k
         write (numbs(i),1010) (next(j),j=1,k)
10    r = r + dr
 
1001  format (i5)
1002  format (i4)
1003  format (i3)
1004  format (g9.3)
1010  format (12a1)
 
      end
 
      subroutine psxlbl (x0, dx, dc, dyl, igrid)
 
c psxlbl - subroutine to put on x-axis labels.
 
      character*12 numbs(40)

      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
 
      integer ic(40)

      common / xyrat /xfac
c
      y = ymin - dyl
 
      x = x0
 
      xdc = .75 * dc
 
      call psnum (x0,xmax,dx,ic,ix1,numbs)
 
      do 10 i = 1, ix1
         if (x.eq.xmin.or.x.eq.xmax) goto 10
         t = x - (float(ic(i)) * xdc) / xfac
         call pstext (t, y, numbs(i), ic(i))
         if (igrid.eq.1) call psline (x, ymin, x, ymax, 10., 0)
10    x = x + dx
 
      end
c-----------------------------------------------------------------
      subroutine psalbl (x,y,ipr,ivar,ird,ifont,ityp,rline,jwidth,
     *                   iop9,fac1)
 
c psalbl - subroutine to output reaction(ityp=0) or ip(ityp=1)
c          name label.
 
      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
 
      real x(ipr),y(ipr)
  
      character*4 lnms, pnms*6, string*132
 
      if (ivar.eq.1) then
            fac = 1.0 * fac1
      else
            fac = 0.75 * fac1
      end if
 
      if (ityp.eq.0) then
c                                       get curve midpoint
         dx = (x(ipr) - x(1))
         dy = (y(ipr) - y(1))
         delta = 1.d30
 
         if (abs(dx)/xlen.gt.abs(dy)/ylen) then
            xmid = x(1) + dx / 2.
 
            do 1 i = 2, ipr
               if (abs(x(i)-xmid).lt.delta) then
                  delta = abs(x(i)-xmid)
                  imid = i
               end if
1           continue
 
         else
            ymid = y(1) + dy / 2.
            do 2 i = 2, ipr
               if (abs(y(i)-ymid).lt.delta) then
                  delta = abs(y(i)-ymid)
                  imid = i
               end if
2           continue
         end if
 
         if (iop9.eq.0) then
c                                   numeric label:
             write (lnms,1000) ird
             jwidth = 0
             call pssctr (ifont,fac,fac,0.0)
             if (ird.lt.10) then
                call pselip (x(imid),y(imid),
     *                      fac*dcx,fac*1.2*dcy,
     *                      rline,jwidth,1)
                call pstext (x(imid)-2.45*dcx*fac,
     *                      y(imid)+0.8*dcy*fac,lnms,4)
             else if (ird.lt.100) then
                call pselip (x(imid),y(imid),
     *                      fac*1.74*dcx,fac*1.6*dcy,
     *                      rline,jwidth,1)
                call pstext (x(imid)-2.71*dcx*fac,
     *                      y(imid)+0.8*dcy*fac,lnms,4)
             else if (ird.lt.1000) then
                call pselip (x(imid),y(imid),
     *                       fac*2.75*dcx,fac*1.83*dcy,
     *                       rline,jwidth,1)
                call pstext (x(imid)-3.04*dcx*fac,
     *                       y(imid)+0.8*dcy*fac,lnms,4)
             else 
                call pselip (x(imid),y(imid),
     *                       fac*3.75*dcx,fac*2.*dcy,
     *                       rline,jwidth,1)
                call pstext (x(imid)-4.*dcx*fac,
     *                       y(imid)+0.8*dcy*fac,lnms,4)
             end if
         else
            if (x(imid).eq.x(imid-1)) then
               theta = 1.5708
            else if (y(imid).eq.y(imid-1)) then
               theta = 0.0
            else 
c                                   text label, get angle:
               theta = atan ( ((y(imid)-y(imid-1)) / ylen)
     *                      / ((x(imid)-x(imid-1)) / xlen) )
            end if 
 
            call rxntxt (string,iend)
c                                   normalized x text length:
            clx = iend * dcx * fac  / xlen / 2.
c                                   normalized y text displacement:
            cly = .5 * dcy / ylen
c                                   get displacements from midpoint:
            dy = (sin(theta) * clx + cos(theta) * cly) * ylen
 
            dx = (cos(theta) * clx - sin(theta) * cly) * xlen
 
            theta = 57.29578 * theta
 
            call pssctr (ifont,fac,fac,theta)
            call pstext (x(imid)-dx,y(imid)-dy,string,iend)
 
         end if
      else
c                                  invariant point labels:
         if (ird.gt.999) then
            write (pnms,1040) ird
         else if (ird.gt.99) then 
            write (pnms,1010) ird
         else if (ird.gt.9) then
            write (pnms,1020) ird
         else
            write (pnms,1030) ird
         end if
 
         call pssctr (ifont,1.2*fac,1.2*fac,0.0)
         call pstext (x(1)+.7*dcx,y(1)+.5*dcy,pnms,5)
 
      end if
 
1000  format (i4)
1010  format ('(',i3,') ')
1020  format ('(',i2,')  ')
1030  format ('(',i1,')   ')
1040  format ('(',i4,')')
 
      end
 
      subroutine psvdrw (n4,pname,iop0,iop1,jwidth,jop0)
C----------------------------------------------------------------
 
c psvdrw - subroutine to output schreinemakers diagrams.
 
      character*72 pname(4), yes*1, prompt*14

      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
      common/ excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
c---------------------------------------------------------------
 
      iop2 = 0
      iop3 = 0
      iop5 = 0
      iop6 = 0
      iop7 = 0
      iop8 = 1
 
      fac1 = .6
      fac2 = .2
      fac3 = .05
  
      call pssctr (8,1.2,1.2,0.)
 
      call psipts 
 
      call pssctr (8,1.6,1.6,0.)

      x = xmin - .15 * xlen

      call pstext (x, ymax+.32*ylen, pname(1), 0)
      call pssctr (8,1.,1.,0.)

      y = ymax + 0.27 * ylen

      do 30 i = 2, 4
         call pstext (x,y,pname(i),0)
30       y = y - 0.03 * ylen
 
 
1000  format (a1)
1030  format (/,' Enter minimum fraction of the axes length that a',/
     *        ' curve must be to receive a text label (0-1): ',/)
1070  format (/,' Change default labelling of curve segments (y/n)?',/)
1080  format (/,' Reset default size for text labels (y/n)? ',/)
1090  format (/,' Scale default text size by a factor of: ',/)
1110  format (/,' Enter minimum fraction of the axes length that a',/
     *        ' curve must be to receive a numeric label (0-',f5.3,
     *        '): ',/)
1120  format (/,' Show only without phases (y/n)? ',/)
1130  format (/,' Show only with phases (y/n)? ',/)
1140  format (/,' Show only with assemblage (y/n)? ',/)
1150  format (/,' Restrict phase fields (y/n)? ',/)
1160  format (/,' Suppress high variance equilibria (y/n)? ',/)
1170  format (/,' Suppress pseudounivariant curves (y/n)? ',/)
1180  format (/,' Suppress pseudoinvariant points (y/n)? ',/)
1190  format (/,' Suppress point labels (y/n)? ',/)
1200  format (/,1x,g13.6,' is an invalid value.',/)
1210  format (/,' Fit curves with B-splines (y/n)? ',/)
1220  format (/,' Suppress curve labels (y/n)? ',/)
1230  format (/,' Modify default equilibrium labelling (y/n)?',/)
 
      end 

c---------------------------------------------------------------
      subroutine rname (iw,prompt)

      character*10 xnams, xnam, prompt*14

      common/ excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
      common/ excl4 /xnams(50,3)

      jxct = 1

110   write (*,1040) prompt
      read (*,1020) xnam

      if (xnam.eq.' ') goto 210

      call matchi (xnam,iex(jxct,iw),jex(jxct,iw))

      if (iex(jxct,iw).eq.-1) then
         write (*,1100) xnam
         goto 110
      end if

      xnams(jxct,iw) = xnam
      jxct = jxct + 1

      goto 110
 
210   ixct(iw) = jxct - 1

1020  format (a10)
1040  format (/,' Enter the name of a phase ',a14,' fields ',
     *        /,' (left justified, <cr> to finish): ',/)
1100  format (/,' No such entity as ',a10,', try again: ',/)


      end 

c---------------------------------------------------------------
      subroutine pscurv (n4,iop0,iop1,iop2,iop4,iop5,iop6,iop7,
     *                      iop8,fac1,fac2,fac3,jwidth)
 
c pscurv - subroutine to output curves.
 
      integer  k1, k0, k2, k, kex(9)
 
      parameter (k1=1000,k2=6000,k0=1000)
 
      real x(k0), y(k0)
 
      integer idr, lchk(k2)
 
      character*10 names*8, xnams
 
      common/ cst8 /names(k1)
      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
      common/ rxn /vnu(8),idr(8),ivct,iplus(8),iminus(8)
      common/ excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
      common/ excl4 /xnams(50,3)/ phase /ikp(k1)

      save lchk
 
      do 100 i = 1, k2
100      lchk(i) = 0

      do 30 i = 1, 3
30       ict(i) = 0
  
10    read (n4,*) ipt,ird,ivar,ivct,(idr(i),i=1,ivct),
     *            (vnu(i),i=1,ivct)
 
      if (ipt.eq.1) goto 99
      ipr = ipt/2

      if (ird.gt.k2) then
         write (*,*) ' you gotta problem, increase k2 in pscurv'
         stop
      end if

      if (ipr.gt.k0) then
         write (*,*) ' you gotta problem, increase k0 in pscurv'
         stop
      end if
 
      read (n4,*)    (x(i),y(i),i=1,ipr)
 
      if (iop4.eq.1.and.ivar.gt.1) goto 10
 
      if (iop5.eq.1.or.iop6.eq.1.or.iop7.eq.1) then  

         ifail = 1

         if (iop5.eq.1.and.ivct.ge.ixct(1)) then         
c                            show only with assemblage:
            itic = 0
            do 2 i = 1, ivct
c                            if you get a match then look at
c                            look for the next phase
               call checki (1,idr(i),kex(i))
                  if (kex(i).ge.0) then
 
                     if (isoct.gt.0.and.kex(i).ne.0.and.
     *                              i.gt.1.and.itic.gt.0) then
                        do 1 k = 1, i - 1
1                          if (kex(k).eq.kex(i)) goto 2
                     end if
                     itic = itic + 1
                  end if
2           continue
c                             itic must = ixct if all phases match
            if (itic.lt.ixct(1))  goto 50
c                             if here the assemblage contains
c                             all the phases requested:
            ict(1) = ict(1) + 1
            ifail = 0 
 
         end if

50       if (iop6.eq.1.and.ivct.ne.0) then
 
            do 5 j = 1, ivct
               call checki (2,idr(j),itis)
               if (itis.ge.0) then
c                            name matches a phase in the field
                  ict(2) = ict(2) + 1
                  goto 60
               end if
 
5           continue
c                             no match
            ifail = 0
         end if


60       if (iop7.eq.1.and.ivct.ne.0) then
            do 3 j = 1, ivct
               call checki (3,idr(j),itis)
               if (itis.ge.0) then
c                            name matches a phase in the field
                  ict(3) = ict(3) + 1
                  ifail = 0 
                  goto 70
               end if
3           continue
c                            no match
         end if

70       if (ifail.eq.1) goto 10 

      end if
 
      if (iop1.eq.1) then
         jpr = 0
         do 20 i = 1, ipr
            if (x(i).gt.xmax.or.x(i).lt.xmin.or.
     *          y(i).gt.ymax.or.y(i).lt.ymin) goto 20
            jpr = jpr + 1
            x(jpr) = x(i)
            y(jpr) = y(i)
20       continue
         if (jpr.eq.0) goto 10
         ipr = jpr
      end if
 
      if (ivar.eq.1) then
         iwidth = 1
      else if (ivar.eq.98) then
         ivar = 1
         iwidth = 2
      else if (ivar.eq.99) then
         ivar = 1
         iwidth = 0
      else
         iwidth = 0
      end if
 
      rline = ivar
      iwidth = iwidth * jwidth
 
      if (iop8.eq.0) then
         call pspyln (x,y,ipr,rline,iwidth,0)
      else
         call psbspl (x,y,ipr,rline,iwidth,0)
      end if
 
      if (ird.eq.0) goto 10
 
      if (iop2.eq.0.and.lchk(ird).eq.0) then
 
         yfrac = abs(y(ipr)-y(1)) / ylen
         xfrac = abs(x(ipr)-x(1)) / xlen
         if (xfrac.lt.fac3.and.yfrac.lt.fac3) then
c                                     curve is too short
            goto 10
         else if (xfrac.lt.fac2.and.yfrac.lt.fac2) then
c                                     use a numeric label
            call psalbl (x,y,ipr,ivar,ird,7,0,rline,iwidth,0,fac1)
         else
c                                     use a text label
            call psalbl (x,y,ipr,ivar,ird,7,0,rline,iwidth,1,fac1)
         end if
 
         if (ird.gt.k2) then 
            write (*,1000) k2
            stop 
         end if 

         lchk(ird) = 1
 
      end if
 
      goto 10
 
99    if (iop5.eq.1) write (6,*) ict(1),
     *               ' curves have the assemblage: ',
     *               (xnams(k,1),' ',k = 1, ixct(1))

      if (iop6.eq.1) write (6,*) ict(2),
     *               ' curves have none of the phases: ',
     *               (xnams(k,2),' ',k = 1, ixct(2))

      if (iop7.eq.1) write (6,*) ict(3),
     *               ' curves have one of the phases: ',
     *               (xnams(k,3),' ',k = 1, ixct(3))

1000  format (' Too many reactions, increase parameter k2 (',
     *       i4,') in routine pscurv',/)

      end
c---------------------------------------------------------------
      subroutine plumin (ip,im)

c subprogram to order a reactants according to sign)

      common/ rxn /vnu(8),idr(8),ivct,iplus(8),iminus(8)

      real vp(8), vm(8)

      ip = 0
      im = 0
c                             load id's of phases with + or - coeffs
      do 10 i = 1, ivct
         if (vnu(i).gt.0.0) then
            ip = ip + 1
            vp(ip) = vnu(i)
            iplus(ip) = idr(i)
         else
            im = im + 1
            vm(im) = vnu(i)
            iminus(im) = idr(i)
         end if
10    continue

      do 20 i = 1, im
         vnu(i) = vm(i)
20       idr(i) = iminus(i)

      do 30 i = 1, ip
         vnu(i+im) = vp(i)
30       idr(i+im) = iplus(i)

      end
c---------------------------------------------------------------
      subroutine rxntxt (string,iend)
 
c subprogram to write a text label for a reaction
 
      integer h9, k1
 
      parameter (k1=1000,h9=18)
 
      character*8 names, text(255)*1, fname*10, string*132
  
      common/ csta7 /fname(h9)/ cst8 /names(k1)/ phase /ikp(k1)
      common/ rxn /vnu(8),idr(8),ivct,iplus(8),iminus(8)
 
c                             load id's of phases with + or - coeffs
      call plumin (ip,im)
c                             now dump the names into the array text
      ist = 1
      is = 1
80    do 20 i = is, im
         id = idr(i)
         if (ikp(id).eq.0) then
c                             simple compound:
            read (names(id),1000) (text(j), j = ist, ist + 7)
            text(ist+8) = ' '
            ist = ist + 9
         else
c                             solution phases:
            read (fname(ikp(id)),1000) (text(j), j = ist, ist + 9)
            text(ist+10) = '('
            read (names(id),1000) (text(j), j = ist + 11, ist + 18)
            text(ist+19) = ')'
            text(ist+20) = ' '
            ist = ist + 21
         end if
20    continue
 
      if (is.eq.1) then
         text(ist) = '='
         text(ist+1) = ' '
         ist = ist + 2
         is = im + 1
         im = ivct
         goto 80
      else
         text(ist) = ' '
      end if
c                             now filter out blanks
      iend = 1
      do 40 i = 2, ist
         if (text(i).eq.' '.and.text(i+1).eq.' ') then
            goto 40
         else if (text(i).eq.' '.and.text(i+1).eq.')') then
            goto 40
         else if (text(i).eq.' '.and.text(i+1).eq.'(') then
            goto 40
         end if
      iend = iend + 1
      text(iend) = text(i)
40    continue
 
      if (iend.gt.130) iend = 132
      write (string,1000) (text(i),i=1,132)
 
1000  format (132a1)
 
      end
c---------------------------------------------------------------
      subroutine psipts 
 
c psipts - subprogram to output invariant points.

      parameter (k9=2000)
 
      character*10 xnams
 
      integer kex(9), k

      common/ excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
      common/ excl4 /xnams(50,3)
      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
      common / xypts /xpt(k9),ypt(k9),isym(k9),ipts
  
      do 20 i = 1, ipts

         x = xpt(i)
         y = ypt(i)
         r = 0.78

 
         if (isym(i).lt.4) then
            if (isym(i).eq.0) then

               call pselip (x,y,r*dcx,r*dcy,1.,0,7)

            else if (isym(i).eq.1) then
 
               call psrect (x-r*dcx,x+r*dcx,y-r*dcy,y+r*dcy,1.,0,7)

            else if (isym(i).eq.2) then

               call pselip (x,y,r*dcx,r*dcy,1.,0,1)

            else if (isym(i).eq.3) then

               call psrect (x-r*dcx,x+r*dcx,y-r*dcy,y+r*dcy,1.,0,1)

            end if 

         else 
 
            r = 0.38

            if (isym(i).eq.4) then

               call pselip (x,y,r*dcx,r*dcy,1.,0,7)

            else if (isym(i).eq.5) then
 
               call psrect (x-r*dcx,x+r*dcx,y-r*dcy,y+r*dcy,1.,0,7)

            else if (isym(i).eq.6) then

               call pselip (x,y,r*dcx,r*dcy,1.,0,1)

            else if (isym(i).eq.7) then

               call psrect (x-r*dcx,x+r*dcx,y-r*dcy,y+r*dcy,1.,0,1)

            end if 

         end if 

 20    continue
 
99    end
 
      subroutine matchi (unnown,itis,icpd)
c----------------------------------------------------------------
 
c matchi - subroutine to determine if the string unnown is a valid
c          solution or compound name.
 
c   itis = 0 if compound, = ikp if solution, and =-1 if invalid
c   icpd = the id of the compound if itis = 0
 
      character*10 sname, names*8, unnown
 
      integer k1, h9
 
      parameter (k1=1000,h9=18)
 
      common/ excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
      common/ cst8 /names(k1)/ csta7 /sname(h9)/ phase /ikp(k1)
 
      if (isoct.ne.0) then
         do 10 i = 1, isoct
            if (unnown.eq.sname(i)) then
               itis = i
               goto 99
             end if
10       continue
      end if
 
      do 20 i = 1, iphct
         if (unnown.eq.names(i)) then
            itis = 0
            icpd = i
            goto 99
         end if
20    continue
 
      itis = -1
99    end
 
 
      subroutine checki (iw,iun,itis)
c----------------------------------------------------------------
 
c checki - subroutine to determine if the cpd iun is in the
c          list iex or jex solution or compound name.
 
c   itis = -1 if not, itis>=0 if it is.
 
      integer k1
 
      parameter (k1=1000)
 
      common/ excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
      common/ phase /ikp(k1)
 
      if (ikp(iun).ne.0) then
         id = ikp(iun)
         do 10 i = 1, ixct(iw)
            if (id.eq.iex(i,iw)) then
               itis = iex(i,iw)
               goto 99
             end if
10       continue
      end if
 
      do 20 i = 1, ixct(iw)
         if (iun.eq.jex(i,iw)) then
            itis = 0
            goto 99
         end if
20    continue
 
      itis = -1
99    end

c----------------------------------------------------------------------
      subroutine psmixd (n4,iop0,icopt)

      integer h9
 
c psmixd - subroutine to draw binary mixed variable diagrams

      parameter (k1=1000,h9=18)
  
      character names*8, vname*30, title*72, sname*10, string*132, y*1
      character tname(5)*8
  
      integer idss(10), idf(3), jphi(k1)

      real v(5)

      common/ rxn /vnu(8),idr(8),ivct,iplus(8),iminus(8)
      common/ vs /vmin(5),vmax(5),iv/ vsa /vname(5)
      common/ cst8 /names(k1)/ csta7 /sname(h9)/ phase /ikp(k1)
      common/ tx /x(k1),iphi(k1),ivph(k1),iphct,ib,istct
      common / wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
      common / xyrat /xfac
c                                  read simple variables

      read (n4,*) icp,istct,iphct,ipoint,ib,ifyn,isyn,ipot,isoct

      if (icp.ne.2) then 
         write (*,*) ' Sorry, PSVDRAW only works',
     *               ' for binary mixed variable diagrams.'
         goto 99
      end if 
 
      if (iv.gt.5.or.ib.gt.k1.or.ipot.gt.5) then
         write (*,*) ' dimensioning error in psmixd '
         goto 99
      end if

      if (isoct.ne.0) write (*,1060)
 
      read (n4,1000) (tname(i), i = 1, ipot)
      read (n4,*) (v(i), i = 1, ipot)
      read (n4,1010) title
c                                  names
      read (n4,1020) (names(i),i=1,iphct)
c                                  phase coordinates
      read (n4,*) (x(i), i = istct, iphct)
c                                  read stable phase ids
      read (n4,*) (iphi(i), i = 1, ib)
c                                  read saturated phase id's
      goto (10),isyn
 
      read (n4,*) isat
      read (n4,*) (idss(i),i=1,isat)
c                                  read index of y variable
10    read (tname(1),1020) vname(2)

      read (n4,1020) vname(1)
c                                  read solution identifier flags
      read (n4,*) (ikp(i),i=1,iphct)
c                                  read solution names
      if (isoct.ne.0) read (n4,1050) (sname(i),i=1,isoct)

      read (n4,*) vmin(2), vmax(2) 
      vmin(1) = 0.0
      vmax(1) = 1.0

      call psaxop (iop0,iop1,jop0,jwidth,icopt)
c                              get some other options
      iop1 = 1
      iop2 = 0
      iop3 = 0

      fac = 1.
      rx = 0.5 * dcx/2./xfac
      ry = 0.5 * dcy/2.

      if  (iop0.eq.1) then 
         write (*,2050)
         read (*,2010) y
         if (y.eq.'y'.or.y.eq.'Y') iop2 = 1

         write (*,2000)
         read (*,2010) y
         if (y.eq.'y'.or.y.eq.'Y') then 
            write (*,2020) 
            read (*,*) fac
         end if 
         write (*,2030)
         read (*,2010) y
         if (y.eq.'y'.or.y.eq.'Y') then
            iop1 = 0
         else 
            write (*,2040)
            read (*,2010) y
            if (y.eq.'y'.or.y.eq.'Y') iop1 = 2
         end if 
         if (isoct.gt.0) then
            write (*,2060)
            read (*,2010) y
            if (y.eq.'y'.or.y.eq.'Y') iop3 = 1
         end if 
      end if 

      t0 = vmin(2)
      tlast = t0 - t0     
c                              get the variance of each compound:
      do 30 i = 1, ib

30       call getvar (i,iop3)

130   read (n4,*) ird, ivct, ivar, t1, (idr(i), i = 1, ivct),
     *                                 (vnu(i), i = 1, ivct)

      if (ivct.eq.1) goto 90

      do 135 i = 1, ib 
135      jphi(i) = iphi(i)
      jb = ib 

      call plumin (jplus,jminus)

      do 20 i = 2, ib - 1
         rline = ivph(i)
20       if (rline.ne.0.0) call psline 
     *                     (x(iphi(i)),t0,x(iphi(i)),t1,rline,0)

         isum = 0
         idif = 0

         do 50 i = 1, ivct
            if (ikp(idr(i)).ne.0) then
               isum = isum + 1
               do 60 j = 1, idif
60                if (idf(j).eq.ikp(idr(i))) goto 50
               idif = idif + 1
               idf(idif) = ikp(idr(i))
            end if 
50       continue 
c                              consider different cases:
      if (ivct.eq.2) then
c                              get index (id) of reacted phase:
         do 40 i = 1, ib
            if (iphi(i).eq.idr(1)) then
               i1 = i - 1 
               if (i1.lt.1) i1 = 1
               id1 = iphi(i1)
               it = i
               i2 = i + 1
               if (i2.gt.ib) i2 = ib 
               id2 = iphi(i2)   
               goto 55
            end if
40       continue
         write (*,*) 'nope'
         write (*,*) (iphi(i),i=1,ib)
         write (*,*) idr(1), ird,t1
         goto 99
c                              check if only a compositional
c                              change in a solution:
55       if (isum.eq.2.and.ikp(idr(1)).eq.ikp(idr(2))) then
c                              draw an open dot, but don't
c                              do anything else:         
            call pselip (x(idr(1)),t1,rx,ry,1.,0,0)
            iphi(it) = idr(2)          
            goto 130
         end if  
c                              draw dot         
         call pselip (x(idr(1)),t1,rx,ry,1.,0,7)
c                              draw line
         call psline (x(id1),t1,x(id2),t1,1.,0)
c                              replace reacted phase:
         iphi(it) = idr(2)
         call getvar (it,iop3)
         if (it.gt.1) call getvar (it-1,iop3)
         if (it.lt.ib) call getvar (it+1,iop3)

      else  
c                              classify reaction, jminus = 2 
c                              eutectoid, else peritectoid.
         if (jminus.eq.2) then
 
            i1 = idr(1)
            i2 = idr(2)
            i0 = idr(3)
c                              find indices of old phases:
            it = 0
            do 70 i = 1, ib
               if (iphi(i).eq.i1) id1 = i
70             if (iphi(i).eq.i2) id2 = i 
               
         else 

            i0 = idr(1)
            i1 = idr(2)
            i2 = idr(3)
c                              find indices of old phases:
            do 80 i = 1, ib
               if (iphi(i).eq.i1) id1 = i
80             if (iphi(i).eq.i2) id2 = i

         end if 

         if (id1.gt.id2) then
            it = id1
            jt = i1
            i1 = i2
            i2 = jt
            id1 = id2
            id2 = it
            if (jminus.eq.2) then
               idr(1) = i1
               idr(2) = i2
            else 
               idr(2) = i1
               idr(3) = i2
            end if
         end if

         if (isum.lt.2.or.idif.eq.3) then 
c                              all phases different
c                              draw line
            call psline (x(i1),t1,x(i2),t1,1.,0)
            call pselip (x(i0),t1,rx,ry,1.,0,7)

         else if (isum.eq.2) then
            if (idif.eq.2) then 
c                              all phases different
               call psline (x(i1),t1,x(i2),t1,1.,0)
               call pselip (x(i0),t1,rx,ry,1.,0,7)

            else 
c                              one solution + one compound
               if (ikp(i0).eq.0) then
c                              compound in the middle
c                              change variance of reaction
                  ivar = 1

                  call pselip (x(i0),t1,rx,ry,1.,0,7)

                  call psline (x(i1), t1, x(i2), t1, 1., 0)          

               else 
c                              pseudoinvariant
                  if (ikp(i0).eq.0) then
                     call psline (x(i1),t1,x(i2),t1,1.,0)
                  else if (ikp(i1).eq.0) then
                     call psline (x(i0),t1,x(i2),t1,1.,0)
                  else 
                     call psline (x(i0),t1,x(i1),t1,1.,0)
                  end if 
               end if
            end if

         else if (isum.eq.3.and.idif.eq.1.and.igo.eq.0) then
c                              reaction on solvus
c                              check if on left line
            itot = 0
            call miscib (x(i1),x(i0),ikp(i0),imis,igo)
            if (imis.eq.0) call psline (x(i0),t1,x(i1),t1,1.,0)
            itot = itot + imis
            call miscib (x(i0),x(i2),ikp(i0),imis,igo)
            itot = itot + imis
            if (imis.eq.0) call psline (x(i0),t1,x(i2),t1,1.,0)
            if (itot.eq.0) then
               ivar = 1
               call pselip (x(i0),t1,rx,ry,1.,0,7)
            end if 


         else 
c                              two solutions present.
c                              solvus possible, find
c                              the pseudocompounds of
c                              the same solution:
            if (ikp(i0).ne.ikp(i1).and.ikp(i0).ne.ikp(i2)) then
c                              i1 and i2 are the same:
               call miscib (x(i1),x(i2),ikp(i1),imis,igo)
            else if (ikp(i0).eq.ikp(i1)) then
c                              i0 and i1 are the same:
               call miscib (x(i1),x(i0),ikp(i0),imis,igo)
            else 
c                              i0 and i2 are the same:
               call miscib (x(i0),x(i2),ikp(i0),imis,igo)
            end if 

            if (imis.eq.1) then
                  ivar = 1
c                              eutectic/peritectic with solvus
                  call psline (x(i1),t1,x(i2),t1,1.,0)
                  call pselip (x(i0),t1,rx,ry,1.,0,7)
            else if (ikp(i1).eq.ikp(i0)) then
c                              pseudounivariant, left
               call psline (x(i1),t1,x(i0),t1,1.,0)

            else if (ikp(i2).eq.ikp(i0)) then
c                              pseudounivariant, right
               call psline (x(i2),t1,x(i0),t1,1.,0)

            else
c                              else center
c                              compound in the middle
c                              change variance:
               itoc = 1
               do 210 j = 1, ib
                  if (iphi(j).eq.i0) goto 210
                  if (ikp(iphi(j)).eq.ikp(i0)) itoc = 0
210            continue 

               if (itoc.eq.1) ivar = 1

               if (ivar.eq.1) call pselip 
     *                        (x(idr(1)),t1,rx,ry,1.,0,7)

               call psline ( x(iphi(id1)), t1,
     *                       x(iphi(id2)), t1, 1., 0)

            end if 
         end if 
c                              get new chemography:
         if (jminus.eq.2) then
c                              eutectoid, number of phases
c                              increases.
            do 100 i = ib, id2, -1
               iphi(i+1) = iphi(i)
100            ivph(i+1) = ivph(i)
            ib = ib + 1
            iphi(id1+1) = i0
            do 110 i = id1, id1 + 2
110            call getvar (i,iop3)
         else
c                              peritectoid, number of phases
c                              decreases.
             do 120 i = id2, ib
                iphi(i-1) = iphi(i)
120             ivph(i-1) = ivph(i)
            ib = ib - 1
            do 140 i = id1, id1 + 1
140            call getvar (i,iop3)
         end if            
      end if

      if (iop2.eq.1) then 
         do 170 i = 1, ib - 1
            if (ikp(iphi(i)).eq.0) goto 170
            i1 = i + 1
            if (ikp(iphi(i)).ne.ikp(iphi(i1))) goto 170
            do 160 j = 1, jb - 1
               if (x(jphi(j)).gt.x(iphi(i))) then
                  goto 170
               else if (x(jphi(j)).eq.x(iphi(i))) then
                  j1 = j + 1
                  if (ikp(jphi(j)).eq.ikp(iphi(i)).and.
     *                ikp(jphi(j)).eq.ikp(jphi(j1))) then
c                                  draw a rectangle from
c                                  i-i1-j-j1
                      call psrect (x(iphi(i)),x(iphi(i1)),
     *                             t0,t1,0.,iwidth,2)
                  end if
               end if
160         continue
170      continue
      end if 

      t0 = t1 

      if (iop1.eq.0) then 
         goto 130
      else if (iop1.eq.1) then
         if (ivar.ne.1) goto 130 
         call rxntxt (string,iend)
      else 
         call rxntxt (string,iend)
      end if 

      call pssctr (7,fac,fac,0.)
      ttext = t1 + .9 * dcy 
      if (ttext.lt.tlast+2.1*dcy) ttext = tlast + 2.1*dcy
      call pstext (xmax+2.*dcx,ttext,string,iend)
      tlast = ttext

      goto 130         

90    t1 = vmax(2)
c                                   fill in last part of one phase regions
      if (iop2.eq.1) then 
         do 180 i = 1, ib - 1
            if (ikp(iphi(i)).eq.0) goto 180
            i1 = i + 1
            if (ikp(iphi(i)).ne.ikp(iphi(i1))) goto 180
c                                  draw a rectangle from
c                                  i-i1-j-j1
                      call psrect (x(iphi(i)),x(iphi(i1)),
     *                             t0,t1,0.,iwidth,2)
180      continue
      end if 

      do 150 i = 2, ib - 1
         rline = ivph(i)
         if (rline.eq.0.0) goto 150
         call psline (x(iphi(i)),t0,x(iphi(i)),t1,rline,0)
150      continue

      call psaxes (jwidth,jop0)

1000  format (2x,a8)
1010  format (a72)
1020  format (10(a8))
1050  format (8a10)
1060  format (/,' WARNING: Psvdraw may not draw t-x diagrams',
     *          ' correctly if immiscibility',/,' occurs in a',
     *          ' projected ternary or higher order solution, to',
     *          ' avoid',/,' problems turn the miscibility test',
     *          ' off (modify default options).',/)
2000  format (/,' Modify default text scaling (y/n)?',/)
2010  format (a1)
2020  format (/,' Enter the scaling factor:',/)
2030  format (/,' Suppress reaction labels (y/n)?',/)
2040  format (/,' Show pseudounivariant reaction labels (y/n)',
     *        /)
2050  format (/,' Try to fill one phase fields (y/n)?',/)
2060  format (/,' Skip tests for immiscibility (y/n)?',/)
 
99    end
c-------------------------------------------------------------------
      subroutine getvar (i,igo)
 
c getvar - subroutine to get variance of compound i in a binary row

c     ivphi set 1 if true compound
c     ivphi set 0 if pseudocompound
c     ivphi set 2 if solvus limb and igo = 0.
c     if igo = 1 skip miscibility test
  
      parameter (k1=1000)
  
      common/ phase /ikp(k1)
      common/ tx /x(k1),iphi(k1),ivph(k1),iphct,ib,istct

      if (i.eq.1.or.i.eq.ib) then 
         ivph(i) = 1
         goto 30
      end if 

         i1 = i - 1
         i2 = i + 1

         id1 = iphi(i1)        
         id = iphi(i)
         id2 = iphi(i2)

         if (ikp(id).eq.0) then 
c                              true compound
            ivph(i) = 1

         else if (ikp(id1).eq.ikp(id).and.ikp(id2).eq.ikp(id)) then
c                              only one solution:
            ivph(i) = 0
            call miscib (x(id1), x(id), ikp(id), imis, igo)
            if (imis.eq.1) ivph(i) = 1
            call miscib (x(id), x(id2), ikp(id), imis, igo)
            if (imis.eq.1) ivph(i) = 1
           
         else 

            ivph(i) = 1

         end if 

30    end 
c-------------------------------------------------------------------
      subroutine miscib (x1, x2, ids, imis, igo)

c miscib - subroutine check for immiscibility in a binary phase

c imis = 1 => solvus between solution(ids) compositions x1 and x2
  
      parameter (k1=1000)
  
      character*8 names

      common/ cst8 /names(k1) 
      common/ phase /ikp(k1)
      common/ tx /x(k1),iphi(k1),ivph(k1),iphct,ib,istct

      imis = 0
c                                disabled cause of projections
      goto (99), igo

      do 10 i = istct, iphct
         if (ikp(i).ne.ids) goto 10
         if (x(i).gt.x1.and.x(i).lt.x2) then 
            imis = 1
            goto 99
         end if 
10    continue
99    end 
