C DOCC - program to calculate Do-Cc temperatures with the fit obtained 
C by Anovitz and Essene 1987.
C      
      IMPLICIT REAL (A-Z)                                     
C                                         coefficients for eq 23
      A = -2360.0
      B = -0.01345
      C = 2620.0 
      D = 2608.0
      E = 334.0 
C                                         coefficients for eq 31
      AA = 1718.0
      BB = -10610.0
      CC = 22.49 
      DD = -26260.0
      EE = 1.333
      FF = 0.32837D7 
C 
10    WRITE (6,*) 'Enter a 1 if you want to enter mole fractions:'
      READ (5,*) MOLE
C
      IF (MOLE.EQ.1.) THEN 
        WRITE (6,*) 'Enter X CaCO3:'
        READ (5,*) XCA
        WRITE (6,*) 'Enter X MgCO3:'
        READ (5,*) XMG
        WRITE (6,*) 'Enter X FeCO3:'
        READ (5,*) XFE
        WRITE (6,*) 'Enter X MnCO3:'
        READ (5,*) XMN
        XFM = XFE + XMN 
      ELSE 
        WRITE (6,*) 'Enter wt % CaCO3:'
        READ (5,*) WCA
        WRITE (6,*) 'Enter wt % MgCO3:'
        READ (5,*) WMG
        WRITE (6,*) 'Enter wt % FeCO3:'
        READ (5,*) WFE
        WRITE (6,*) 'Enter wt % MnCO3:'
        READ (5,*) WMN
C
        MCA = WCA/(44.01+56.08)
        MMG = WMG/(44.01+40.32)
        MFE = WFE/(44.01+71.85)
        MMN = WMN/(44.01+70.94)
C
        MTOT = MCA+MMG+MFE+MMN
C   
        XCA = MCA/MTOT
        XMG = MMG/MTOT
        XFM = (MMN+MFE)/MTOT
C      
      END IF 
C
      WRITE (6,*) 'X(Ca)   =',XCA
      WRITE (6,*) 'X(Mg)   =',XMG
      WRITE (6,*) 'X(Fe+Mn)=',XCA
C                                      first solve equation 23
      T1 = A*XMG + B/XMG**2 + C*XMG**2 + D*XMG**0.5 + E
C                                      now eq 31 (iron correction)
      T2 = T1 + AA*XFM + BB*XFM**2 + CC*XFM/XMG
     *        + DD*XFM*XMG + EE*(XFM/XMG)**2 + FF*(XFM*XMG)**2
C
      WRITE (6,*) 'Uncorrected T(K), T(C)',T1,T1-273.15
      WRITE (6,*) 'Corrected   T(K), T(C)',T2,T2-273.15
C
      GOTO 10
99    STOP
      END
